Modelresources incorrectly set json fields to use Widget instead of JSONWidget
Description

See for example:
In [1]: from pulp_rpm.app.modelresource import PackageCategoryResource

In [2]: PackageCategoryResource.fields["group_ids"].__dict___
Out[2]:
{'attribute': 'group_ids',
'default': 1list,
'column_name': 'group_ids',
'widget': <import_export.widgets.Widget at 0x7f£032a86aeb0>,
'readonly': False,
'saves_null_values': True}

This is caused by django-import-export not properly handling django.db.models.JSONField. In django-import-export 2.5.0 it only
checks for django.contrib.postgres.fields.JSONField.

The fix is here but it hasn't been released yet:

https://github.com/django-import-export/django-import-export/commit/f348ef3782e60d44a2cedd0062179f0b9c798510

Related issues:
Related to Pulp - Issue #9324: Backport #9307 to 3.15 CLOSED - CURRENTRELEASE

Associated revisions

Revision 225360ca - 08/31/2021 03:20 PM - daviddavis
Set WIDGET_MAP for model resources to handle JSON fields

fixes #9307

History

#1 - 08/27/2021 04:18 PM - daviddavis

- Subject changed from Modelresources incorrectly set widgets to Widget instead of JSONWidget to Modelresources incorrectly set json fields to use
Widget instead of JSONWidget

#2 - 08/27/2021 04:19 PM - daviddavis

| filed an issue to ask for a new release of django-import-export: https://github.com/django-import-export/django-import-export/issues/1321

#3 - 08/27/2021 04:38 PM - daviddavis
- Status changed from NEW to ASSIGNED

- Assignee set to daviddavis
https://github.com/django-import-export/django-import-export/commit/f348ef3782e60d44a2cedd0062179f0b9c798510
https://github.com/django-import-export/django-import-export/issues/1321

#4 - 08/27/2021 10:16 PM - pulpbot
- Status changed from ASSIGNED to POST

PR: https://github.com/pulp/pulpcore/pull/1585

#5 - 08/31/2021 03:20 PM - daviddavis
- Status changed from POST to MODIFIED

Applied in changeset pulpcore|225360cabb3e563806234c869734c5965b824ec?.

#6 - 08/31/2021 05:19 PM - daviddavis
- Related to Issue #9324: Backport #9307 to 3.15 added

#7 - 08/31/2021 08:16 PM - daviddavis
- Sprint/Milestone deleted (3.15.1)

#8 - 10/05/2021 08:27 PM - pulpbot
- Sprint/Milestone set to 3.16.0

#9 - 10/05/2021 08:53 PM - pulpbot
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE
https://pulp.plan.io/projects/pulp/repository/pulpcore/revisions/225360cabb3e563806234c869734c5965b824ec7
